# DSPOptimizations Mod
This mod adds optimizations to DSP. Few optimizations are available currently, but more will be added in the future.

## Important Notice
The low resolution shells optimization is now obsolete with DSP v0.9. If you had lower resolution shells in your save, then the vanilla game will update them incorrectly. As of v1.0.6, this mod should update such modded shells correctly.

## Features
- Dense spheres with shells now impact the game's framerate much less
	- e.g. the framerate with a single sphere layer with 5240 shells with the game paused went from 8 fps to 24 fps
- Multithreading is added for the logic controlling belts going in and out of stations
	- this should greatly reduce the CPU time under the "Storage" category in the performance window
- Dyson node logic has been optimized to take 20% as long
- Hidden sphere layers under construction cause less lag
- Shadows can be disabled in the config

## Commands
The following commands may be used with the [developer console](https://dsp-wiki.com/Developer_Console):
- `-resetLocalFactory`
	- completely resets the factory data for the nearby planet. This can eliminate lag that would have persisted even after deleting all buildings
	- requires a planet to be loaded
	- does not reset terrain, vegetation, or veins
- `-resetLocalSwarm`
	- completely resets all swarms for the nearby star, deleting all sails. This can eliminate permanent save bloat
	- requires the player to be near a star (within ~2 lyrs - the star name should be visible in the bottom left)
- `-resetLocalSphereLayer layerId`
	- instantly deletes a sphere layer without releasing sails
	- requires the player to be near a star (within ~2 lyrs - the star name should be visible in the bottom left)
	- `layerId` should be an integer between 1 and 10 corresponding to the ID of the sphere layer you wish to delete
- `-resetAllSpheresAndSwarms`
	- instantly deletes all dyson spheres and swarms for all stars. No sails will be released
	- if you have the dyson editor open while running this command, reopen it to see the changes

## Installation Note
This mod depends on [DSPModSave](https://dsp.thunderstore.io/package/CommonAPI/DSPModSave/). Make sure that you have the version under the CommonAPI name, rather than the old version released by crecheng. The old version has bugs, and may cause problems. The old version of the mod is marked as deprecated.

## Compatibility
This mod is most likely not compatible with the [Nebula Mod](https://dsp.thunderstore.io/package/nebula/NebulaMultiplayerModApi/), however compatibility will be added in the future.

## Bug Reports
If you encounter any bugs or issues, then please contact me either on discord at Selsion#0769, or by raising an issue on the [mod github page](https://github.com/Selsion/DSPMods/tree/main/DSPOptimizations).

## Changelog
- v1.1.6
	- added a compatibility fix for the black box mod
	- added factory, swarm, and sphere reset commands
- v1.1.5
	- fixed a bug where selecting other saves in the save menu can reset storage multithreading info
- v1.1.4
	- fixed a bug where multithreading didn't work properly for PLSs. re-enabled storage multithreading
- v1.1.3
	- temporarily disabled the storage multithreading because of potential mod compatibility issues
- v1.1.2
	- added multithreading for station storage logic
- v1.1.1
	- improved fps for dense spheres by optimizing shell rendering
	- reduced lag caused by shader buffers being synced when a hidden layer is under construction
- v1.1.0
	- optimized dyson node logic
- v1.0.6
	- Removed the low resolution shells feature

## Attributions
Icon(s) made by [Freepik](https://www.freepik.com) from www.flaticon.com